function [coords,classes] = genDataSet(numModalities,numClust,minPts,maxPts,minRadius,maxRadius,maxX,maxY,splitProb)

coords = [];
classes = [];

for i=1 : numClust
    if (maxPts>minPts)
        numPts = minPts + randi(maxPts - minPts);
    else
        numPts = minPts;
    end
    c2 = [];
    
    for j=1: numModalities
        %c1 = zeros(numPts,2);
        
        % optionally split the circle in two different ones
        numPts_a = 0; c1_a=[]; split = randi(10)>(10-splitProb*10);
        if (split)
            numPts_a = randi(numPts-1);
            radius = minRadius+randi(maxRadius-minRadius);
            x = radius+randi(maxX);
            y = radius+randi(maxY);
            c1_a = genDataCircle(numPts_a,0,radius,x,y);
        end
        numPts_b = numPts - numPts_a;
        radius = minRadius+randi(maxRadius-minRadius);
        x = radius+randi(maxX);
        y = radius+randi(maxY);
        c1_b = genDataCircle(numPts_b,0,radius,x,y);
        c1 = cat(1, c1_a, c1_b);
        
        c2 = cat(3, c2, c1);
    end
    coords = cat(1, coords, c2);
        
    classes = [classes ones(1,numPts)*i];
end

